---
title: General guidelines for all code
slug: MDN/Guidelines/Code_guidelines/General
tags:
  - Code
  - General
  - Guide
  - Guidelines
  - MDN Meta
---
<div>{{MDNSidebar}}</div>

<p class="summary">The following code example guidelines apply to all code, whether we are talking about HTML, CSS, JavaScript, or something else.</p>

<h2 id="In_this_article">In this article</h2>

<ul>
 <li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/General#Indentation_spacing_size">Indentation, spacing, size</a>

  <ul>
   <li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/General#Indentation">Indentation</a></li>
   <li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/General#Code_line_length">Code line length</a></li>
   <li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/General#Code_block_height">Code block height</a></li>
  </ul>
 </li>
 <li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/General#Guidelines_for_displaying_examples">Guidelines for displaying examples</a>
  <ul>
   <li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/General#Size_of_rendered_example">Size of rendered example</a></li>
   <li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/General#Use_of_images_and_other_media">Use of images and other media</a></li>
   <li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/General#Use_of_color">Use of color</a></li>
   <li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/General#Highlight_good_and_bad_practice_examples">Highlight good and bad practice examples</a></li>
  </ul>
 </li>
 <li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/General#Writing_syntax_sections_on_reference_pages">Writing syntax sections on reference pages</a></li>
</ul>

<h2 id="Indentation_spacing_size">Indentation, spacing, size</h2>

<h3 id="Indentation">Indentation</h3>

<p>All code should use 2 spaces for indentation, for example:</p>

<pre class="brush: html example-good notranslate">&lt;div&gt;
  &lt;p&gt;This is my paragraph.&lt;/p&gt;
&lt;/div&gt;</pre>

<pre class="brush: js example-good notranslate">function myFunc() {
  if(thingy) {
    console.log('Yup, that worked.');
  }
}</pre>

<h3 id="Code_line_length">Code line length</h3>

<p>Lines of code should be a maximum of 80 characters long (64 for <a href="https://github.com/mdn/interactive-examples">interactive examples</a>). You should break lines sensibly for the sake of readability, but not at the expense of best practices.</p>

<p>For example, this is not great:</p>

<pre class="brush: js example-bad notranslate">let tommyCat = 'Said Tommy the Cat as he reeled back to clear whatever foreign matter may have nestled its way into his mighty throat. Many a fat alley rat had met its demise while staring point blank down the cavernous barrel of this awesome prowling machine.';</pre>

<p>This is better, but somewhat awkward:</p>

<pre class="brush: js notranslate">let tommyCat = 'Said Tommy the Cat as he reeled back to clear whatever foreign '
+ 'matter may have nestled its way into his mighty throat. Many a fat alley rat '
+ 'had met its demise while staring point blank down the cavernous barrel of '
+ 'this awesome prowling machine.';</pre>

<p>Even better is to use a template literal:</p>

<pre class="brush: js example-good notranslate">let tommyCat = `Said Tommy the Cat as he reeled back to clear whatever foreign
  matter may have nestled its way into his mighty throat. Many a fat alley rat
  had met its demise while staring point blank down the cavernous barrel of
  this awesome prowling machine.`;</pre>

<h3 id="Code_block_height">Code block height</h3>

<p>Code blocks should be as long as they need to be, but no longer. Ideally, aim for something short like 15-25 lines. If a code block is going to be a lot longer, consider just showing the most useful snippet, and link to the full example on a GitHub repo or codepen, say.</p>

<h2 id="Guidelines_for_displaying_examples">Guidelines for displaying examples</h2>

<h3 id="Size_of_rendered_example">Size of rendered example</h3>

<p>The MDN main content pane is about 700px wide on desktop, so embedded MDN examples must look OK at that width (set the width of embedded examples at 100%).</p>

<p>For height, we'd recommend keeping the rendered example at below 700px in height if at all possible, for maximum onscreen legibility.</p>

<p>You should also think about making your examples responsive to  some degree, so they are also useful on mobile devices.</p>

<h3 id="Use_of_images_and_other_media">Use of images and other media</h3>

<p>Sometimes you'll want to include images or other media in an example. If you do:</p>

<ul>
 <li>Make sure their license allows you to use them. Try to use media that has a very permissive license such as <a href="https://creativecommons.org/share-your-work/public-domain/cc0/" rel="nofollow">CC0</a>, or at least one that is compatible with our general content license —  <a class="external text external-icon" href="http://creativecommons.org/licenses/by-sa/2.5/" rel="nofollow noopener" title="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike license</a> (CC-BY-SA).</li>
 <li>For images, run them through <a href="https://tinypng.com" rel="nofollow">https://tinypng.com</a> or <a href="https://imageoptim.com" rel="nofollow">https://imageoptim.com</a>, to reduce the page weight of the examples.</li>
 <li>For <code>SVG</code>, run the code through <a href="https://jakearchibald.github.io/svgomg/">SVGOMG</a>, and ensure that the <code>SVG</code> file has an empty line at the end of the file.</li>
 <li>
  <p>When displaying icons on a page (e.g. via {{cssxref("background-image")}}), use the <a href="https://mdn.github.io/mdn-fiori/patterns/css/iconography/">built-in MDN icons</a> where appropriate, and try to match their style in other cases.</p>
 </li>
</ul>

<h3 id="Use_of_color">Use of color</h3>

<p>Lower case for hex, can use keywords for shades and primary colors (e.g. black, white, red), use more complex schemes only when needed (e.g. to include transparency)</p>

<p>Prefer to use keywords for primary and other "basic" colors, for example:</p>

<pre class="brush: css example-good notranslate">color: black;
color: white;
color: red;</pre>

<p>Use rgb() for more complex colors (including semi-transparent ones):</p>

<pre class="brush: css example-good notranslate">color: rgb(0, 0, 0, 0.5);
color: rgb(248, 242, 230);</pre>

<p>If you have to use hex colors, then use lower-case:</p>

<pre class="brush: css example-good notranslate">color: #058ed9;
color: #a39a92;</pre>

<p>and use the short form where relevant:</p>

<pre class="brush: css example-good notranslate">color: #ff0;
color: #fff;</pre>

<p><a href="https://mdn.github.io/mdn-fiori/">MDN's Fiori guidelines</a> (for the front-end codebase) contain a <a href="https://mdn.github.io/mdn-fiori/patterns/scss/variables/">useful set of colors</a> that complement the overall MDN design.</p>

<h3 id="Highlight_good_and_bad_practice_examples">Highlight good and bad practice examples</h3>

<p>As you will notice from looking around these guidelines, the code blocks that are supposed to be good practice examples are highlighted with a smiley face in green, and the code blocks that are supposed to be bad practice examples are highlighted with a sad face in red.</p>

<p>To do this, you first use the MDN editor controls to put your code block in a <code>&lt;pre&gt;</code> block and give it appropriate syntax highlighting. The source of the code will look something like this:</p>

<pre class="notranslate">&lt;pre class="brush: js"&gt;
function myFunc() {
  console.log('Hello!');
};&lt;/pre&gt;</pre>

<p>To make it into a good example, you insert <code>example-good</code> just before the closing quote of the <code>class</code> attribute:</p>

<pre class="notranslate">&lt;pre class="brush: js example-good"&gt;
  ...</pre>

<p>To make it into a bad example, you insert <code>example-bad</code> just before the closing quote of the <code>class</code> attribute:</p>

<pre class="notranslate">&lt;pre class="brush: js example-bad"&gt;
  ...</pre>

<p>We would like to encourage you to use these. You don't need to use these everywhere — only when you are specifically calling out good and bad practices in your code.</p>

<h2 id="Writing_syntax_sections_on_reference_pages">Writing syntax sections on reference pages</h2>

<p>MDN reference pages include Syntax sections that show unambiguously what the syntax of a feature can/should be, for example a JavaScript method, CSS property, HTML element, etc. Guidelines for writing these are given on the <a href="/en-US/docs/MDN/Contribute/Structures/Syntax_sections">Syntax sections</a> document.</p>
